#!/usr/bin/env ruby

l_in=22.396
l_ft=l_in/12.0

mach=1.6
mu=Math.asin(1/mach)
beta=1/Math.tan(mu)

h_in = 31.8
h_ft = h_in/12

experiments=Dir['../morgenstern/lm-*.csv']

experiments.each do |exp|
  puts exp
  out = File.basename(exp,".csv")+".out"
  puts out
  File.open(out,'w') do |f|
    File.open(exp).each do |line|
      col=line.split(',')
      if (!(line =~ /#/)) then
        tau = col[0].to_f
        p = col[1].to_f
        x = tau*l_in + beta*h_in
        f.puts "#{x} #{p} 0 0 0"
      else
        f.puts line
      end
    end
  end
end


