#!/usr/bin/env ruby

l_in=22.396
l_ft=l_in/12.0
b2_in=8.055/2.0
b2_ft=b2_in/12.0

in_rad=Math::PI/180.0

mach=1.6
mu=Math.asin(1/mach)
beta=1/Math.tan(mu)

suffix  = ARGV[0] || "08808"
phi_deg = ARGV[1] || 0
phi_deg = phi_deg.to_f

hl = suffix.to_f*0.0001
h_ft = hl*l_in/12

y_target  =  h_ft*Math.sin(phi_deg*in_rad)
z_target  = -h_ft*Math.cos(phi_deg*in_rad)

y_target = y_target.to_f
z_target = z_target.to_f

puts "h/l=#{hl}, phi=#{phi_deg} : (#{y_target},#{z_target})"

tol = 0.01*hl

out = "ext-#{suffix}-#{sprintf('%02d',phi_deg)}.dat"

File.open(out,'w') do |o|
  o.puts 'VARIABLES = "X" "Y" "Z" "dp/pinf" "tau" "dp*sqrt(R)"'
  File.open('../signatures.csv').each do |participant|
    input = "../submission/"+participant.sub(/08808/,suffix).chomp
    if ( File.exists?(input) ) then
      lines=IO.readlines(input)
      o.puts "ZONE"
      last_x = -1.0e6
      n=0
      lines.each do |line|
        col=line.split
        x = col[0].to_f
        y = col[1].to_f
        z = col[2].to_f
        p = col[3].to_f
        tau = (x-beta*h_ft)/l_ft
        ps = p*Math::sqrt(h_ft/b2_ft)
        next unless ( p.abs > 0.0 )
        dist = (y-y_target)**2 + (z-z_target)**2
        next unless (dist<tol**2)
        next if (x<last_x)
        o.puts "#{x} #{y} #{z} #{p} #{tau} #{ps}"
        n+=1
        last_x = x
      end
    else
      o.puts "ZONE"
      o.puts "0 #{y_target} #{z_target} 0 0 0"
      n=0
    end
    puts "#{n} : #{input}"
  end
end
